// SIGMA APPLICATION EMBED - ROW LEVEL SECURITY

// SECTION 1: DO NOT CHANGE (START)

//1A: USE EXPRESS WEB NODE PACKAGE:
	var express = require('express');
	var app = express();

//1B: FETCH PATH FOR FOLDER CONTAINING HTML PAGE WE ARE EMBEDDING INTO:
	app.get('/', function(req, res) {
	res.sendFile(__dirname + '/index.html');
	});

//1C: DEFINE A ROUTE HANDLER FOR GET REQUESTS TO GIVEN URL:
	app.get('/api/foo', foo);

//1D: CALL FUNCTION AND SET REQUIRED PARAMETERS:
	function foo(req, res) {

//1E: REQUIRE NODE'S CRYPTOGRAPHIC LIBRARY:
	const crypto = require('crypto');

//1F: CREATE A NONCE (NUMBER USED ONCE) BASED ON CRYPTO'S UUID FUNCTION:
	const nonce = crypto.randomUUID();

//1G: Set searchParams = CRYPTO GENERATED NONCE GENERATED EARLIER:
	let searchParams = `?:nonce=${nonce}`;

// END SECTION 1

// SECTION 2 START: REQUIRED TO CHANGE, REPLACE VALUES WITH YOUR OWN

//2A: SET A VALUE FOR EMBED_PATH. THIS IS THE URL CREATED IN SIGMA WHEN YOU CREATE THE EMBED:
	const EMBED_PATH = 'YOUR EMBED_PATH HERE';

//2B: SET A VALUE FOR SECRET. THIS IS THE SECRET CREATED IN SIGMA WHEN YOU CREATE THE EMBED SECRET:
	const EMBED_SECRET = 'YOUR API SECRET HERE';

// NOTE: FROM HERE FORWARD THE URL IS PIECE BY PIECE BY DECLARING "searchParams" AND THEN ADDING EACH ADDITIONAL PARAMETER TO IT WITH ANOTHER IN STEPS:

//2C: SET searchParams = (previous value in searchParams) + CLIENTID:
    	searchParams += '&:client_id=YOUR CLIENTID HERE';

//2E: SET searchParams = (previous value in searchParams) + EMAIL ADDRESS OF USER AUTHENTICATED BY PARENT APPLICATION. WE WILL HARD CODE THAT FOR THE LAB:
	// NOTE: For Embedding, the users should not already exist, Sigma will create them on the fly the first time.
   		searchParams += '&:email=ayanna@morbifoundation.com';

//2F: SET searchParams = (previous value in searchParams) + USERID OF USER AUTHENTICATED BY PARENT APPLICATION. WE WILL HARD CODE THAT TO THE EMAIL ADDRESS FOR THE LAB:
   	searchParams += '&:external_user_id=12345';

//2G: SET searchParams = (previous value in searchParams) + TEAM OF USER:
	// IMPORTANT: The embedded content (WB, Page or Viz) must be shared with the Team for the request to work
  		searchParams += '&:external_user_team=FinanceCreators';

//2H: SET searchParams = (previous value in searchParams) + USER ACCOUNT TYPE:
	// NOTE: The account type for the calling user needs to be specified and the Account Type must exist in Sigma first
    		searchParams += '&:account_type=Creator';

//2I: SET searchParams = (previous value in searchParams) + show_footer:
	// NOTE: This UA determines if the bottom control bar shows for Creators (ie: menus, Workbook Pages. Default is true. Options are true or false. 
    		searchParams += '&:show_footer=true';

//2J: Set searchParams = (previous value in searchParams) + ua_Region:
	// NOTE: UA values are case sensitive. 
		//searchParams += '&:ua_Region=East,West';
		searchParams += '&:ua_ID=23,76';

// END SECTION 2


// SECTION 3: DO NOT CHANGE UNLESS USING DIFFERENT MODE:

//3A: SET searchParams = (previous value in searchParams) + EMBEDDING MODE:
// NOTE: This will always be "userbacked" for Embedding 
	searchParams += '&:mode=userbacked';

//3B: SET searchParams = (previous value in searchParams) + SESSION LENGTH:
// :session_length is defined as the number of seconds the user should be allowed to view the embed before logout
    searchParams += '&:session_length=600';

//3C: SET searchParams = (previous value in searchParams) + THE CURRENT TIME AS UNIX TIMESTAMP:
    searchParams += `&:time=${Math.floor(new Date().getTime() / 1000)}`;

//3D: SET URL_WITH_SEARCH_PARAMS =  EMBED_PATH VALUE IN 2A + FINAL VALUE FOR searchParams:
	const URL_WITH_SEARCH_PARAMS = EMBED_PATH + searchParams;

//3E: ENCRYPT OUTPUT OF 3D WITH 2B INTO SIGNATURE:
	const SIGNATURE = crypto
		.createHmac('sha256', Buffer.from(EMBED_SECRET, 'utf8'))
		.update(Buffer.from(URL_WITH_SEARCH_PARAMS, 'utf8'))
		.digest('hex');

//3F: CONSTRUCT FINAL URL TO SEND FROM COMBINING OUTPUT OF 3D AND 3E:
	const URL_TO_SEND = `${URL_WITH_SEARCH_PARAMS}&:signature=${SIGNATURE}`;

//3G: READY TO SEND ON REQUEST:
	res.status(200).send({url:URL_TO_SEND});
}

//3H: TELL EXPRESS WEB TO LISTEN FOR INBOUND REQUESTS ON PORT 3000:
app.listen(3000);

// SECTION 3: END SECTION 3

//END